import os
import re

import click

SAMPLE_DIR = os.path.join(os.path.dirname(__file__), 'samples')


@click.command('uwsgi')
@click.option('-C', '--uwsgi-conf-dir', default=None)
@click.option('-d', '--dir', default=None)
@click.option('-2', 'py_version', flag_value='2')
@click.option('-3', 'py_version', flag_value='3')
@click.option('-p', '--py-version', )
@click.option('-w', '--write', is_flag=True)
@click.argument('nick', nargs=1)
@click.pass_context
def uwsgi(ctx, dir, nick, py_version, write, uwsgi_conf_dir):
    project_dir = dir or os.getcwd()
    py_version = py_version or 3
    key = 'py{}_exe'.format(py_version)
    try:
        interpreter = ctx.obj.get('projects', key)
    except:
        msg = "Missing key '{}' in conf, add it using'jmb conf edit'".format(key)
        click.secho(msg, fg='red')
        return
    virtualenv = re.sub('/bin/python.*', '', interpreter)
    port = 10000
    conf = os.path.join(SAMPLE_DIR, 'uwsgi.ini')
    with open(conf) as f:
        content = f.read()
    txt = content.format(**locals())
    try:
        uwsgi_conf_dir = uwsgi_conf_dir or ctx.obj.get('uwsgi', 'vassals-dir')
    except:
        uwsgi_conf_dir = '/etc/uwsgi-emperor/vassals-avaiable'
    ini_path = os.path.join(uwsgi_conf_dir, '%s.ini' % nick)
    if write:
        with open(ini_path, 'w') as f:
            f.write(txt)
            msg = "File written in {}".format(ini_path)
            click.secho(msg, fg='blue')
    else:
        print(txt)
