import click

from . import jmb2e3, buildout2
from jmb.tools.utils.functions import execute

@click.group()
def port():
    "port the code to py3 or to buildout2 or..."

@click.command('pep8')
@click.argument('dirs', nargs=-1)
def pep8(dirs):
    """Apply autopep8 with reasonable args"""

    cmd = 'autopep8 -ira --max-line-length=100 --exclude=.hg,bootstrap.py'.split()
    cmd = cmd + list(dirs or '.')
    print(' '.join(cmd))
    execute(cmd + list(dirs or '.'))

port.add_command(jmb2e3.main)
port.add_command(buildout2.migrate_to_buildout2)
port.add_command(pep8)
